Index: /code/trunk/src/orxonox/core/XMLPort.h
===================================================================
--- /code/trunk/src/orxonox/core/XMLPort.h	(revision 871)
+++ /code/trunk/src/orxonox/core/XMLPort.h	(revision 871)
@@ -0,0 +1,282 @@
+/*
+ *   ORXONOX - the hottest 3D action shooter ever to exist
+ *
+ *
+ *   License notice:
+ *
+ *   This program is free software; you can redistribute it and/or
+ *   modify it under the terms of the GNU General Public License
+ *   as published by the Free Software Foundation; either version 2
+ *   of the License, or (at your option) any later version.
+ *
+ *   This program is distributed in the hope that it will be useful,
+ *   but WITHOUT ANY WARRANTY; without even the implied warranty of
+ *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ *   GNU General Public License for more details.
+ *
+ *   You should have received a copy of the GNU General Public License
+ *   along with this program; if not, write to the Free Software
+ *   Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
+ *
+ *   Author:
+ *      Fabian 'x3n' Landau
+ *   Co-authors:
+ *      ...
+ *
+ */
+
+#ifndef _XMLPort_H__
+#define _XMLPort_H__
+
+#include "util/XMLIncludes.h"
+#include "util/MultiTypeMath.h"
+#include "util/tinyxml/ticpp.h"
+#include "util/SubString.h"
+#include "Functor.h"
+#include "Debug.h"
+#include "CoreIncludes.h"
+#include "BaseObject.h"
+
+#include "CorePrereqs.h"
+
+
+#define XMLPortParam(classname, paramname, loadfunction, savefunction, xmlelement, loading) \
+    orxonox::XMLPortClassParamContainer<classname>* xmlcontainer##loadfunction##savefunction = (orxonox::XMLPortClassParamContainer<classname>*)(this->getIdentifier()->getXMLPortParamContainer(paramname)); \
+    if (!xmlcontainer##loadfunction##savefunction) \
+    { \
+        xmlcontainer##loadfunction##savefunction = new orxonox::XMLPortClassParamContainer<classname>(this->getIdentifier()->getName(), std::string(paramname), createFunctor(&classname::loadfunction), createFunctor(&classname::savefunction)); \
+        this->getIdentifier()->addXMLPortParamContainer(paramname, xmlcontainer##loadfunction##savefunction); \
+    } \
+    xmlcontainer##loadfunction##savefunction->port(this, xmlelement, loading)
+
+#define XMLPortParamLoadOnly(classname, paramname, loadfunction, xmlelement, loading) \
+    orxonox::XMLPortClassParamContainer<classname>* xmlcontainer##loadfunction##savefunction = (orxonox::XMLPortClassParamContainer<classname>*)(this->getIdentifier()->getXMLPortParamContainer(paramname)); \
+    if (!xmlcontainer##loadfunction##savefunction) \
+    { \
+        xmlcontainer##loadfunction##savefunction = new orxonox::XMLPortClassParamContainer<classname>(this->getIdentifier()->getName(), std::string(paramname), createFunctor(&classname::loadfunction), 0); \
+        this->getIdentifier()->addXMLPortParamContainer(paramname, xmlcontainer##loadfunction##savefunction); \
+    } \
+    xmlcontainer##loadfunction##savefunction->port(this, xmlelement, loading)
+
+#define XMLPortObject(classname, objectclass, sectionname, loadfunction, savefunction, xmlelement, loading) \
+    orxonox::XMLPortClassObjectContainer<classname, objectclass>* xmlcontainer##loadfunction##savefunction = (orxonox::XMLPortClassObjectContainer<classname, objectclass>*)(this->getIdentifier()->getXMLPortObjectContainer(sectionname)); \
+    if (!xmlcontainer##loadfunction##savefunction) \
+    { \
+        xmlcontainer##loadfunction##savefunction = new orxonox::XMLPortClassObjectContainer<classname, objectclass>(this->getIdentifier()->getName(), std::string(sectionname), &classname::loadfunction, &classname::savefunction); \
+        this->getIdentifier()->addXMLPortObjectContainer(sectionname, xmlcontainer##loadfunction##savefunction); \
+    } \
+    xmlcontainer##loadfunction##savefunction->port(this, xmlelement, loading)
+
+
+namespace orxonox
+{
+    // ###############################
+    // ###  XMLPortParamContainer  ###
+    // ###############################
+    class _CoreExport XMLPortParamContainer
+    {
+        public:
+            XMLPortParamContainer();
+
+            inline const std::string& getName() const
+                { return this->paramname_; }
+
+            XMLPortParamContainer& description(const std::string description);
+            const std::string& getDescription();
+
+            XMLPortParamContainer& defaultValues(const MultiTypeMath& param1 = MT_null, const MultiTypeMath& param2 = MT_null, const MultiTypeMath& param3 = MT_null, const MultiTypeMath& param4 = MT_null, const MultiTypeMath& param5 = MT_null)
+            {
+                this->defaultValues_[0] = param1;
+                this->defaultValues_[1] = param2;
+                this->defaultValues_[2] = param3;
+                this->defaultValues_[3] = param4;
+                this->defaultValues_[4] = param5;
+
+                return (*this);
+            }
+
+        protected:
+            std::string classname_;
+            std::string paramname_;
+            MultiTypeMath defaultValues_[5];
+
+        private:
+            LanguageEntryLabel description_;
+            bool bAddedDescription_;
+            bool bAddedDefaultValues_;
+    };
+
+    template <class T>
+    class XMLPortClassParamContainer : public XMLPortParamContainer
+    {
+        public:
+            XMLPortClassParamContainer(const std::string classname, const std::string paramname, FunctorMember<T>* loadfunction, FunctorMember<T>* savefunction)
+            {
+                this->classname_ = classname;
+                this->paramname_ = paramname;
+                this->loadfunction_ = loadfunction;
+                this->savefunction_ = savefunction;
+            }
+
+            XMLPortParamContainer& port(T* object, Element& xmlelement, bool loading)
+            {
+                if (loading)
+                {
+                    try
+                    {
+                        std::string attribute = xmlelement.GetAttribute(this->paramname_);
+                        if (attribute.size() > 0)
+                        {
+                            SubString tokens(attribute, ",", SubString::WhiteSpaces, false, '\\', '"', '(', ')', '\0');
+                            if ((unsigned int)tokens.size() >= (unsigned int)this->loadfunction_->getParamCount())
+                            {
+                                COUT(5) << object->getLoaderIndentation() << "Loading parameter " << this->paramname_ << " in " << this->classname_ << " (objectname " << object->getName() << ") with ";
+                                if (this->loadfunction_->getParamCount() == 1)
+                                {
+                                    COUT(5) << "1 parameter (using whole string):" << std::endl;
+                                    COUT(5) << object->getLoaderIndentation() << "  " << attribute << std::endl;
+                                    (*this->loadfunction_)(object, MultiTypeMath(attribute));
+                                }
+                                else
+                                {
+                                    COUT(5) << tokens.size() << " parameter (using MultiTypeMath)." << std::endl;
+                                    MultiTypeMath param1 = MT_null, param2 = MT_null, param3 = MT_null, param4 = MT_null, param5 = MT_null;
+                                    if (tokens.size() >= 1) param1 = tokens[0];
+                                    if (tokens.size() >= 2) param2 = tokens[1];
+                                    if (tokens.size() >= 3) param3 = tokens[2];
+                                    if (tokens.size() >= 4) param4 = tokens[3];
+                                    if (tokens.size() >= 5) param5 = tokens[4];
+                                    COUT(5) << object->getLoaderIndentation() << "  " << attribute << std::endl;
+                                    COUT(5) << object->getLoaderIndentation() << "  " << param1 << ", " << param2 << ", " << param3 << ", " << param4 << ", " << param5 << std::endl;
+
+                                    (*this->loadfunction_)(object, param1, param2, param3, param4, param5);
+                                }
+                            }
+                            else
+                            {
+                                COUT(2) << object->getLoaderIndentation() << "Warning: Parameter \"" << this->paramname_ << "\" in \"" << this->classname_ << "\" (objectname: " << object->getName() << ") is incomplete and couln't be loaded." << std::endl;
+                            }
+                        }
+                    }
+                    catch(ticpp::Exception& ex)
+                    {
+                        COUT(1) << std::endl;
+                        COUT(1) << "An error occurred in XMLPort.h while loading attribute '" << this->paramname_ << "' of '" << this->classname_ << "' (objectname: " << object->getName() << ") in " << object->getLevelfile() << ":" << std::endl;
+                        COUT(1) << ex.what() << std::endl;
+                    }
+                }
+                else
+                {
+                    if (this->savefunction_)
+                    {
+//                        xmlelement.SetAttribute(this->paramname_, "...");
+                    }
+                }
+
+                return (*this);
+            }
+
+        private:
+            FunctorMember<T>* loadfunction_;
+            FunctorMember<T>* savefunction_;
+    };
+
+
+    // ################################
+    // ###  XMLPortObjectContainer  ###
+    // ################################
+    class _CoreExport XMLPortObjectContainer
+    {
+        public:
+            XMLPortObjectContainer();
+
+            inline const std::string& getName() const
+                { return this->sectionname_; }
+
+            XMLPortObjectContainer& description(const std::string description);
+            const std::string& getDescription();
+            static bool identifierIsIncludedInLoaderMask(const Identifier* identifier);
+
+        protected:
+            std::string classname_;
+            std::string sectionname_;
+
+        private:
+            LanguageEntryLabel description_;
+            bool bAddedDescription_;
+    };
+
+    template <class T, class O>
+    class XMLPortClassObjectContainer : public XMLPortObjectContainer
+    {
+        public:
+            XMLPortClassObjectContainer(const std::string classname, const std::string sectionname, void (T::*loadfunction)(O*), const O* (T::*savefunction)(unsigned int))
+            {
+                this->classname_ = classname;
+                this->sectionname_ = sectionname;
+                this->loadfunction_ = loadfunction;
+                this->savefunction_ = savefunction;
+            }
+
+            XMLPortObjectContainer& port(T* object, Element& xmlelement, bool loading)
+            {
+                if (loading)
+                {
+                    try
+                    {
+                        Element* xmlsubelement = xmlelement.FirstChildElement(this->sectionname_, false);
+
+                        if (xmlsubelement)
+                        {
+                            for ( ticpp::Iterator<ticpp::Element> child = xmlsubelement->FirstChildElement(false); child != child.end(); child++ )
+                            {
+                                Identifier* identifier = ID(child->Value());
+                                if (identifier)
+                                {
+                                    if (identifier->isA(Class(O)))
+                                    {
+                                        if (this->identifierIsIncludedInLoaderMask(identifier))
+                                        {
+                                            COUT(4) << object->getLoaderIndentation() << "fabricating " << child->Value() << "..." << std::endl;
+                                            O* newObject = (O*)identifier->fabricate();
+                                            newObject->setLoaderIndentation(object->getLoaderIndentation() + "  ");
+                                            newObject->setLevel(object->getLevel());
+                                            newObject->XMLPort(*child, true);
+                                            COUT(4) << object->getLoaderIndentation() << "assigning " << child->Value() << " (objectname " << newObject->getName() << ") to " << this->classname_ << " (objectname " << object->getName() << ")" << std::endl;
+                                            (*object.*this->loadfunction_)(newObject);
+                                            COUT(5) << "  ...fabricated " << child->Value() << " (objectname " << newObject->getName() << ")." << std::endl;
+                                        }
+                                    }
+                                    else
+                                    {
+                                        COUT(2) << object->getLoaderIndentation() << "Warning: '" << child->Value() << "' is not a '" << Class(O)->getName() << "'." << std::endl;
+                                    }
+                                }
+                                else
+                                {
+                                    COUT(2) << object->getLoaderIndentation() << "Warning: '" << child->Value() << "' is not a valid classname." << std::endl;
+                                }
+                            }
+                        }
+                    }
+                    catch(ticpp::Exception& ex)
+                    {
+                        COUT(1) << std::endl;
+                        COUT(1) << "An error occurred in XMLPort.h while loading a '" << Class(O)->getName() << "' in '" << this->sectionname_ << "' of '" << this->classname_ << "' (objectname: " << object->getName() << ") in " << object->getLevelfile() << ":" << std::endl;
+                        COUT(1) << ex.what() << std::endl;
+                    }
+                }
+                else
+                {
+                }
+
+                return (*this);
+            }
+
+        private:
+            void     (T::*loadfunction_)(O*);
+            const O* (T::*savefunction_)(unsigned int);
+    };
+}
+
+#endif /* _XMLPort_H__ */
Index: /code/trunk/src/orxonox/objects/Ambient.cc
===================================================================
--- /code/trunk/src/orxonox/objects/Ambient.cc	(revision 870)
+++ /code/trunk/src/orxonox/objects/Ambient.cc	(revision 871)
@@ -40,4 +40,5 @@
 #include "../core/CoreIncludes.h"
 #include "../Orxonox.h"
+#include "core/XMLPort.h"
 
 #include "Ambient.h"
@@ -45,7 +46,4 @@
 namespace orxonox
 {
-    // create a template instantiations
-    //template class _OrxonoxExport ClassIdentifier<Ambient>;
-
     CreateFactory(Ambient);
 
@@ -61,6 +59,4 @@
     void Ambient::loadParams(TiXmlElement* xmlElem)
     {
-    	Ogre::SceneManager* mgr = orxonox::Orxonox::getSingleton()->getSceneManager();
-
     	if (xmlElem->Attribute("colourvalue"))
     	{
@@ -72,8 +68,26 @@
 	    	String2Number<float>(b, colourvalues[2]);
 
-	    	mgr->setAmbientLight(ColourValue(r,g,b));
+	    	this->setAmbientLight(ColourValue(r, g, b));
 
 	    	COUT(4) << "Loader: Set ambient light: "<<r<<" " << g << " " << b  << std::endl << std::endl;
     	}
    }
+
+   void Ambient::setAmbientLight(const ColourValue& colour)
+   {
+    	Orxonox::getSingleton()->getSceneManager()->setAmbientLight(colour);
+   }
+
+    /**
+        @brief XML loading and saving.
+        @param xmlelement The XML-element
+        @param loading Loading (true) or saving (false)
+        @return The XML-element
+    */
+    void Ambient::XMLPort(Element& xmlelement, bool loading)
+    {
+        BaseObject::XMLPort(xmlelement, loading);
+
+        XMLPortParamLoadOnly(Ambient, "colourvalue", setAmbientLight, xmlelement, loading);
+    }
 }
Index: /code/trunk/src/orxonox/objects/Ambient.h
===================================================================
--- /code/trunk/src/orxonox/objects/Ambient.h	(revision 870)
+++ /code/trunk/src/orxonox/objects/Ambient.h	(revision 871)
@@ -14,12 +14,12 @@
             virtual ~Ambient();
 
-            
             void loadParams(TiXmlElement* xmlElem);
+            virtual void XMLPort(Element& xmlelement, bool loading);
+            void setAmbientLight(const ColourValue& colour);
 
         private:
-            
+
 
     };
-    ExportClass(Ambient, Orxonox);
 }
 
Index: /code/trunk/src/orxonox/objects/Camera.h
===================================================================
--- /code/trunk/src/orxonox/objects/Camera.h	(revision 870)
+++ /code/trunk/src/orxonox/objects/Camera.h	(revision 871)
@@ -14,12 +14,11 @@
             virtual ~Camera();
 
-            
+
             void loadParams(TiXmlElement* xmlElem);
 
         private:
-            
+
 
     };
-    ExportClass(Camera, Orxonox);
 }
 
Index: /code/trunk/src/orxonox/objects/Explosion.h
===================================================================
--- /code/trunk/src/orxonox/objects/Explosion.h	(revision 870)
+++ /code/trunk/src/orxonox/objects/Explosion.h	(revision 871)
@@ -21,5 +21,4 @@
             ParticleInterface* particle_;
     };
-    ExportClass(Explosion, Orxonox);
 }
 
Index: /code/trunk/src/orxonox/objects/Fighter.h
===================================================================
--- /code/trunk/src/orxonox/objects/Fighter.h	(revision 870)
+++ /code/trunk/src/orxonox/objects/Fighter.h	(revision 871)
@@ -90,5 +90,4 @@
             int emitterRate_;
     };
-    ExportClass(Fighter, Orxonox);
 }
 
Index: /code/trunk/src/orxonox/objects/Model.cc
===================================================================
--- /code/trunk/src/orxonox/objects/Model.cc	(revision 870)
+++ /code/trunk/src/orxonox/objects/Model.cc	(revision 871)
@@ -33,4 +33,5 @@
 #include "../core/CoreIncludes.h"
 #include "../Orxonox.h"
+#include "core/XMLPort.h"
 
 #include "Model.h"
@@ -60,4 +61,24 @@
     }
 
+    /**
+        @brief XML loading and saving.
+        @param xmlelement The XML-element
+        @param loading Loading (true) or saving (false)
+        @return The XML-element
+    */
+    void Model::XMLPort(Element& xmlelement, bool loading)
+    {
+        WorldEntity::XMLPort(xmlelement, loading);
+
+        XMLPortParamLoadOnly(Model, "mesh", setMesh, xmlelement, loading);
+
+        create();
+    }
+
+    void Model::setMesh(const std::string& meshname)
+    {
+        this->meshSrc_ = meshname;
+    }
+
     bool Model::create(){
       if(meshSrc_.compare("")!=0){
@@ -71,5 +92,5 @@
 
     void Model::registerAllVariables(){
-      registerVar(&meshSrc_, meshSrc_.length() + 1, network::STRING);
+//      registerVar(&meshSrc_, meshSrc_.length() + 1, network::STRING);
     }
 }
Index: /code/trunk/src/orxonox/objects/Model.h
===================================================================
--- /code/trunk/src/orxonox/objects/Model.h	(revision 870)
+++ /code/trunk/src/orxonox/objects/Model.h	(revision 871)
@@ -18,4 +18,6 @@
             virtual ~Model();
             virtual void loadParams(TiXmlElement* xmlElem);
+            virtual void XMLPort(Element& xmlelement, bool loading);
+            void setMesh(const std::string& meshname);
             bool create();
 
@@ -25,5 +27,4 @@
             void registerAllVariables();
     };
-    ExportClass(Model, Orxonox);
 }
 
Index: /code/trunk/src/orxonox/objects/NPC.h
===================================================================
--- /code/trunk/src/orxonox/objects/NPC.h	(revision 870)
+++ /code/trunk/src/orxonox/objects/NPC.h	(revision 871)
@@ -44,6 +44,4 @@
       static int const NUMELEMENTS = 9;  //number of elements
   };
-  ExportClass(NPC, Orxonox);
-
 }
 #endif /* _NPC_H__ */
Index: /code/trunk/src/orxonox/objects/Projectile.h
===================================================================
--- /code/trunk/src/orxonox/objects/Projectile.h	(revision 870)
+++ /code/trunk/src/orxonox/objects/Projectile.h	(revision 871)
@@ -28,5 +28,4 @@
             Timer<Projectile> destroyTimer_;
     };
-    ExportClass(Projectile, Orxonox);
 }
 
Index: /code/trunk/src/orxonox/objects/Skybox.cc
===================================================================
--- /code/trunk/src/orxonox/objects/Skybox.cc	(revision 870)
+++ /code/trunk/src/orxonox/objects/Skybox.cc	(revision 871)
@@ -38,4 +38,5 @@
 #include "../core/CoreIncludes.h"
 #include "../core/Debug.h"
+#include "core/XMLPort.h"
 
 #include "Skybox.h"
@@ -56,13 +57,29 @@
     void Skybox::loadParams(TiXmlElement* xmlElem)
     {
-    	Ogre::SceneManager* mgr = orxonox::Orxonox::getSingleton()->getSceneManager();
-
     	if (xmlElem->Attribute("src"))
     	{
     		std::string skyboxSrc = xmlElem->Attribute("src");
-	    	mgr->setSkyBox(true, skyboxSrc);
+	    	this->setSkybox(skyboxSrc);
 
 	    	COUT(4) << "Loader: Set skybox: "<< skyboxSrc << std::endl << std::endl;
     	}
    }
+
+   void Skybox::setSkybox(const std::string& skyboxname)
+   {
+    	Orxonox::getSingleton()->getSceneManager()->setSkyBox(true, skyboxname);
+   }
+
+    /**
+        @brief XML loading and saving.
+        @param xmlelement The XML-element
+        @param loading Loading (true) or saving (false)
+        @return The XML-element
+    */
+    void Skybox::XMLPort(Element& xmlelement, bool loading)
+    {
+        BaseObject::XMLPort(xmlelement, loading);
+
+        XMLPortParamLoadOnly(Skybox, "src", setSkybox, xmlelement, loading);
+    }
 }
Index: /code/trunk/src/orxonox/objects/Skybox.h
===================================================================
--- /code/trunk/src/orxonox/objects/Skybox.h	(revision 870)
+++ /code/trunk/src/orxonox/objects/Skybox.h	(revision 871)
@@ -16,12 +16,12 @@
             virtual ~Skybox();
 
-            
             void loadParams(TiXmlElement* xmlElem);
+            virtual void XMLPort(Element& xmlelement, bool loading);
+            void setSkybox(const std::string& skyboxname);
 
         private:
-            
+
 
     };
-    ExportClass(Skybox, Orxonox);
 }
 
Index: /code/trunk/src/orxonox/objects/SpaceShip.cc
===================================================================
--- /code/trunk/src/orxonox/objects/SpaceShip.cc	(revision 870)
+++ /code/trunk/src/orxonox/objects/SpaceShip.cc	(revision 871)
@@ -44,4 +44,5 @@
 #include "../particle/ParticleInterface.h"
 #include "Projectile.h"
+#include "core/XMLPort.h"
 
 #include "SpaceShip.h"
@@ -123,4 +124,6 @@
         this->brakeLoop(loop);
 */
+        this->init();
+
         COUT(3) << "Info: SpaceShip was loaded" << std::endl;
     }
@@ -132,16 +135,6 @@
     }
 
-    void SpaceShip::setConfigValues()
-    {
-        SetConfigValue(bInvertYAxis_, false).description("Set this to true for joystick-like mouse behaviour (mouse up = ship down).");
-        SetConfigValue(reloadTime_, 0.125).description("The reload time of the weapon in seconds");
-        SetConfigValue(testvector_, Vector3()).description("asdfblah");
-    }
-
-    void SpaceShip::loadParams(TiXmlElement* xmlElem)
-    {
-        Model::loadParams(xmlElem);
-
-
+    void SpaceShip::init()
+    {
         // START CREATING THRUSTER
         this->tt_ = new ParticleInterface(Orxonox::getSingleton()->getSceneManager(),"twinthruster" + this->getName(),"Orxonox/engineglow");
@@ -197,5 +190,16 @@
 
         // END of testing crosshair
-
+    }
+
+    void SpaceShip::setConfigValues()
+    {
+        SetConfigValue(bInvertYAxis_, false).description("Set this to true for joystick-like mouse behaviour (mouse up = ship down).");
+        SetConfigValue(reloadTime_, 0.125).description("The reload time of the weapon in seconds");
+        SetConfigValue(testvector_, Vector3()).description("asdfblah");
+    }
+
+    void SpaceShip::loadParams(TiXmlElement* xmlElem)
+    {
+        Model::loadParams(xmlElem);
 /*
         if (xmlElem->Attribute("forward") && xmlElem->Attribute("rotateupdown") && xmlElem->Attribute("rotaterightleft") && xmlElem->Attribute("looprightleft"))
@@ -242,21 +246,61 @@
     	if (xmlElem->Attribute("camera"))
     	{
-            Ogre::Camera *cam = Orxonox::getSingleton()->getSceneManager()->createCamera("ShipCam");
-            this->camNode_ = this->getNode()->createChildSceneNode("CamNode");
-/*
-//            node->setInheritOrientation(false);
-            cam->setPosition(Vector3(0,50,-150));
-            cam->lookAt(Vector3(0,20,0));
-            cam->roll(Degree(0));
-*/
-
-            cam->setPosition(Vector3(-200,0,35));
-//            cam->setPosition(Vector3(0,-350,0));
-            cam->lookAt(Vector3(0,0,35));
-            cam->roll(Degree(-90));
-
-            this->camNode_->attachObject(cam);
-            Orxonox::getSingleton()->getOgrePointer()->getRoot()->getAutoCreatedWindow()->addViewport(cam);
+    	    this->setCamera();
     	}
+    }
+
+    void SpaceShip::setCamera(const std::string& camera)
+    {
+        Ogre::Camera *cam = Orxonox::getSingleton()->getSceneManager()->createCamera("ShipCam");
+        this->camNode_ = this->getNode()->createChildSceneNode("CamNode");
+/*
+//        node->setInheritOrientation(false);
+        cam->setPosition(Vector3(0,50,-150));
+        cam->lookAt(Vector3(0,20,0));
+        cam->roll(Degree(0));
+*/
+
+        cam->setPosition(Vector3(-200,0,35));
+//        cam->setPosition(Vector3(0,-350,0));
+        cam->lookAt(Vector3(0,0,35));
+        cam->roll(Degree(-90));
+
+        this->camNode_->attachObject(cam);
+        Orxonox::getSingleton()->getOgrePointer()->getRoot()->getAutoCreatedWindow()->addViewport(cam);
+    }
+
+    void SpaceShip::setMaxSpeed(float value)
+    { this->maxSpeed_ = value; }
+    void SpaceShip::setMaxSideAndBackSpeed(float value)
+    { this->maxSideAndBackSpeed_ = value; }
+    void SpaceShip::setMaxRotation(float value)
+    { this->maxRotation_ = value; this->maxRotationRadian_ = Radian(value); }
+    void SpaceShip::setTransAcc(float value)
+    { this->translationAcceleration_ = value; }
+    void SpaceShip::setRotAcc(float value)
+    { this->rotationAcceleration_ = value; this->rotationAccelerationRadian_ = Radian(value); }
+    void SpaceShip::setTransDamp(float value)
+    { this->translationDamping_ = value; }
+    void SpaceShip::setRotDamp(float value)
+    { this->rotationDamping_ = value; this->rotationDampingRadian_ = Radian(value); }
+
+    /**
+        @brief XML loading and saving.
+        @param xmlelement The XML-element
+        @param loading Loading (true) or saving (false)
+        @return The XML-element
+    */
+    void SpaceShip::XMLPort(Element& xmlelement, bool loading)
+    {
+        Model::XMLPort(xmlelement, loading);
+
+        XMLPortParamLoadOnly(SpaceShip, "camera", setCamera, xmlelement, loading);
+        XMLPortParamLoadOnly(SpaceShip, "maxSpeed", setMaxSpeed, xmlelement, loading);
+        XMLPortParamLoadOnly(SpaceShip, "maxSideAndBackSpeed", setMaxSideAndBackSpeed, xmlelement, loading);
+        XMLPortParamLoadOnly(SpaceShip, "maxRotation", setMaxRotation, xmlelement, loading);
+        XMLPortParamLoadOnly(SpaceShip, "transAcc", setTransAcc, xmlelement, loading);
+        XMLPortParamLoadOnly(SpaceShip, "rotAcc", setRotAcc, xmlelement, loading);
+        XMLPortParamLoadOnly(SpaceShip, "transDamp", setTransDamp, xmlelement, loading);
+        XMLPortParamLoadOnly(SpaceShip, "rotDamp", setRotDamp, xmlelement, loading);
     }
 
Index: /code/trunk/src/orxonox/objects/SpaceShip.h
===================================================================
--- /code/trunk/src/orxonox/objects/SpaceShip.h	(revision 870)
+++ /code/trunk/src/orxonox/objects/SpaceShip.h	(revision 871)
@@ -21,7 +21,18 @@
             SpaceShip();
             ~SpaceShip();
+            void init();
             void setConfigValues();
             virtual void loadParams(TiXmlElement* xmlElem);
+            virtual void XMLPort(Element& xmlelement, bool loading);
             virtual void tick(float dt);
+
+            void setCamera(const std::string& camera = "");
+            void setMaxSpeed(float value);
+            void setMaxSideAndBackSpeed(float value);
+            void setMaxRotation(float value);
+            void setTransAcc(float value);
+            void setRotAcc(float value);
+            void setTransDamp(float value);
+            void setRotDamp(float value);
 
             bool mouseMoved(const OIS::MouseEvent &e);
@@ -75,5 +86,4 @@
             int emitterRate_;
     };
-    ExportClass(SpaceShip, Orxonox);
 }
 
Index: /code/trunk/src/orxonox/objects/SpaceshipSteeringObject.cc
===================================================================
--- /code/trunk/src/orxonox/objects/SpaceshipSteeringObject.cc	(revision 870)
+++ /code/trunk/src/orxonox/objects/SpaceshipSteeringObject.cc	(revision 871)
@@ -40,6 +40,5 @@
 #include "util/Tokenizer.h"
 #include "util/String2Number.h"
-#include "../core/Debug.h"
-
+#include "core/CoreIncludes.h"
 #include "SpaceshipSteeringObject.h"
 
Index: /code/trunk/src/orxonox/objects/Test.h
===================================================================
--- /code/trunk/src/orxonox/objects/Test.h	(revision 870)
+++ /code/trunk/src/orxonox/objects/Test.h	(revision 871)
@@ -30,5 +30,4 @@
 
 #include "core/BaseObject.h"
-#include "../core/CoreIncludes.h"
 
 namespace orxonox
@@ -74,4 +73,5 @@
         public:
             A1B2() { RegisterObject(A1B2); }
+//            virtual void test() = 0;
     };
 
@@ -116,4 +116,5 @@
         public:
             A1B2C1() { RegisterObject(A1B2C1); }
+//            void test() { std::cout << "test!\n"; }
     };
 
Index: /code/trunk/src/orxonox/objects/Tickable.cc
===================================================================
--- /code/trunk/src/orxonox/objects/Tickable.cc	(revision 871)
+++ /code/trunk/src/orxonox/objects/Tickable.cc	(revision 871)
@@ -0,0 +1,13 @@
+#include "core/CoreIncludes.h"
+#include "Tickable.h"
+
+namespace orxonox
+{
+    /**
+        @brief Constructor: Registers the object in the Tickable-list
+    */
+    Tickable::Tickable()
+    {
+        RegisterRootObject(Tickable);
+    }
+}
Index: /code/trunk/src/orxonox/objects/Tickable.h
===================================================================
--- /code/trunk/src/orxonox/objects/Tickable.h	(revision 870)
+++ /code/trunk/src/orxonox/objects/Tickable.h	(revision 871)
@@ -44,6 +44,5 @@
 
 #include "../OrxonoxPrereqs.h"
-
-#include "../core/CoreIncludes.h"
+#include "core/OrxonoxClass.h"
 
 namespace orxonox
@@ -62,10 +61,6 @@
 
         protected:
-            /**
-                @brief Constructor: Registers the object in the Tickable-list
-            */
-            Tickable() { RegisterRootObject(Tickable); }
+            Tickable();
     };
-    ExportAbstractClass(Tickable, Orxonox);
 
     //! The TickFrameListener calls the tick(dt) function of all Tickables every frame.
